<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
<el-form-item prop="code">
  <template #label>
    <span>
      {{ t('FactoryModeling.FactoryStructure.dialogCodeLabel') }}
      <el-tooltip :content="t('FactoryModeling.FactoryStructure.dialogCodeTooltip')" placement="top">
        <Icon icon="ep:question-filled" />
      </el-tooltip>
    </span>
  </template>
  <el-row :gutter="10" style="width: 100%;">
    <el-col :xs="24" :sm="18" :md="16" :lg="14" :xl="12">
      <el-input
        :disabled="formData.isCode == true || formType === 'update'"
        v-model="formData.code"
        :placeholder="t('FactoryModeling.FactoryStructure.dialogCodePlaceholder')"
      />
    </el-col>
    <el-col :xs="24" :sm="6" :md="4" :lg="3" :xl="2">
      <div>
        <el-switch 
          v-model="formData.isCode" 
          :disabled="formType === 'update'"
        />
      </div>
    </el-col>
  </el-row>
</el-form-item>

      <el-form-item :label="t('FactoryModeling.FactoryStructure.dialogParentLabel')" prop="parentId">
        <el-tree-select
          v-model="formData.parentId"
          :data="organizationTree"
          :props="defaultProps"
          check-strictly
          default-expand-all
          :placeholder="t('FactoryModeling.FactoryStructure.dialogParentPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.FactoryStructure.dialogNameLabel')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('FactoryModeling.FactoryStructure.dialogNamePlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.FactoryStructure.dialogOrgClassLabel')" prop="orgClass">
        <el-radio-group v-model="formData.orgClass">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_CLASS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item prop="sort">
        <template #label>
            <span>
              {{ t('FactoryModeling.FactoryStructure.dialogSortLabel') }}
              <el-tooltip :content="t('FactoryModeling.FactoryStructure.dialogSortTooltip')" placement="top">
                <Icon icon="ep:question-filled" />
              </el-tooltip>
            </span>
        </template>
        <el-input v-model="formData.sort" :placeholder="t('FactoryModeling.FactoryStructure.dialogSortPlaceholder')" />
      </el-form-item>
      <el-form-item v-if="formData.orgClass == 'workplace' || formData.orgClass == 'process'" prop="orgType">
       <template #label>
            <span>
              {{ t('FactoryModeling.FactoryStructure.dialogOrgTypeLabel') }}
              <el-tooltip :content="t('FactoryModeling.FactoryStructure.dialogOrgTypeTooltip')" placement="top">
                <Icon icon="ep:question-filled" />
              </el-tooltip>
            </span>
        </template>
        <el-select v-model="formData.orgType" @change="handleOrgTypeChange" :placeholder="t('FactoryModeling.FactoryStructure.dialogOrgTypePlaceholder')">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.FactoryStructure.dialogMachineLabel')" v-if="formData.orgClass == 'workplace'" prop="machineId">
        <!-- <el-tree-select
          v-model="formData.machineId"
          :data="machineComponentTree"
          :props="defaultProps"
          check-strictly
          default-expand-all
          placeholder="请选择机台"
        /> -->
        <el-select v-model="formData.machineId" :placeholder="t('FactoryModeling.FactoryStructure.dialogMachinePlaceholder')">
          <el-option
            v-for="item in deviceList"
            :key="item.id"
            :label="item.deviceName"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="组织状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item> -->
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('FactoryModeling.FactoryStructure.dialogSubmitButton') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('FactoryModeling.FactoryStructure.dialogCancelButton') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { OrganizationApi, OrganizationVO } from '@/api/mes/organization'
import { defaultProps, handleTree } from '@/utils/tree'
import {MachineComponentApi} from "@/api/mes/machine";
import {DeviceLedgerApi, DeviceLedgerVO} from "@/api/mes/deviceledger";

/** 产线工位 表单 */
defineOptions({ name: 'OrganizationForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

// const deviceList = ref<DeviceVO[]>([]) // 列表
const deviceList = ref<DeviceLedgerVO[]>([]) // 列表
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  parentId: undefined,
  sort: undefined,
  workerUserId: undefined,
  machineId: undefined,
  phone: undefined,
  email: undefined,
  isEnable: undefined,
  status: undefined,
  orgClass: undefined,
  orgType: undefined,
  isCode: undefined
})
const formRules = reactive({
  name: [{ required: true, message: t('FactoryModeling.FactoryStructure.validatorNameRequired'), trigger: 'blur' }],
  parentId: [{ required: true, message: t('FactoryModeling.FactoryStructure.validatorParentRequired'), trigger: 'blur' }],
  orgClass: [{ required: true, message: t('FactoryModeling.FactoryStructure.validatorOrgClassRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const organizationTree = ref() // 树形结构
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrganizationApi.getOrganization(id)
    } finally {
      formLoading.value = false
    }
  }
  await getOrganizationTree()
  if (type == 'create'  || typeof formData.value.machineId != 'number') {
    deviceList.value = await DeviceLedgerApi.getDeviceLedgerListByNoUsed()
  } else {
    deviceList.value = await DeviceLedgerApi.getDeviceLedgerList2ByNoUsed(formData.value.machineId)
  }
  //await getMachineComponentTree()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrganizationVO
    if (formType.value === 'create') {
      await OrganizationApi.createOrganization(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrganizationApi.updateOrganization(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    parentId: undefined,
    sort: 0,
    workerUserId: undefined,
    machineId: undefined,
    phone: undefined,
    email: undefined,
    isEnable: undefined,
    status: undefined,
    orgClass: undefined,
    orgType: undefined,
    isCode: true
  }
  formRef.value?.resetFields()
}

/** 获得产线工位树 */
const getOrganizationTree = async () => {
  organizationTree.value = []
  const data = await OrganizationApi.getOrganizationList()
  const root: Tree = { id: 0, name: t('FactoryModeling.FactoryStructure.orgTreeRootName'), children: [] }
  root.children = handleTree(data, 'id', 'parentId')
  organizationTree.value.push(root)
}

const machineComponentTree = ref() // 树形结构
/** 获得机台树 */
const getMachineComponentTree = async () => {
  machineComponentTree.value = []
  const data = await MachineComponentApi.getPipelineAndMachineList()
  const root: Tree = { id: 0, name: 'ALL', children: [] }
  root.children = handleTree(data, 'id', 'parentId')
  machineComponentTree.value.push(root)
}


/** 初始化 **/
onMounted(async () => {
  //console.log("ssss")
  //deviceList.value = await DeviceLedgerApi.getDeviceLedgerListByNoUsed()
})
</script>
